<template>
    <div>
        <ob-modal
            ref="ob-modal"
            :title="'Создание новой методики'"
            :size="'medium'"
            :isShowControls="true"
            :isSubmitDisabled="!formValid"
            @cancel="close"
            @submit="onSave"
            class="sb-popup sb-card-popup"
        >
            <ob-form
                :isShowControls="false"
                :formData="formData"
            >
                <div class="edit-method">
                    <ob-input
                        class="edit-method__input"
                        :label="'Наименование'"
                        :required="true"
                        :placeholder="'Введите'"
                        type="text"
                        v-model="formData.name"
                    />
                </div>
                <div class="edit-method">
                    <ob-selector
                        class=""
                        :items="activities"
                        :required="true"
                        displayExp="name"
                        :placeholder="'Выберите'"
                        :label="'Направление деятельности'"
                        :disabled="!activitiesLength"
                        v-model="formData.participantActivityUuid"
                    />
                </div>
                <div class="edit-method">
                    <ob-textarea
                        :placeholder="'Введите'"
                        :label="'Краткое описание'"
                        rows="10"
                        class="text-field"
                        v-model="formData.description"
                    />
                </div>
            </ob-form>
        </ob-modal>        
    </div>
</template>

<script>
import { uuid } from 'vue-uuid'
import ObForm from "common-components/src/obComponents/obForm";
import ObModal from 'common-components/src/obComponents/obModal';
import ObSelector from 'common-components/src/obComponents/obSelect';
import ObInput from 'common-components/src/obComponents/obInput';
import ObTextarea from 'common-components/src/obComponents/obTextarea';
import { CREATE_BONUS } from '../../../store/modules/bonus_methodologies';
import { GET_BONUS } from '../../../store/modules/bonus_methodology';
import { GET_BONUS_ACTIVITIES } from '../../../store/modules/bonus_activities';

export default {
    data() {
        return {
            formData: {
                name: '',
                participantActivityUuid: '',
                description: ''
            }
        }
    },
    components: {
        ObModal,
        ObSelector,
        ObInput,
        ObTextarea,
        ObForm
    },
    computed: {
        savePossible: ({ formData: { name } }) => name,
        activities() {
            return this.$store.getters.getBonusActivities;
        },
        activitiesLength() {
            return this.activities.length;
        },
        formValid() {
            if (this.formData.participantActivityUuid && this.formData.name) {
                return true
            } else {
                return false
            }
        }
    },
    created() {
        this.$store.dispatch(GET_BONUS_ACTIVITIES);
    },
    methods: {
        async onSave() {
            const payload = {
                uuid: uuid.v4(),
                name: this.formData.name,
                description: this.formData.description,
                participantActivityUuid: this.formData.participantActivityUuid
            };
            try {
                this.$store.dispatch(CREATE_BONUS, payload)
                    .then(() => {
                        this.$store.dispatch(GET_BONUS, payload.uuid)
                        this.clearForm();
                    });
            } catch (e) {
                console.log('error', e);
            }
            this.close();
        },
        open(data) {
            this.$refs['ob-modal'].open();
            if (uuid) {
                this.formData.name = data;
            }
        },
        clearForm() {
            this.formData.name = '';
            this.formData.participantActivityUuid = '';
            this.formData.description = '';
        },
        close() {
            this.clearForm();
            this.$refs['ob-modal'].close();
        }
    }
}
</script>

<style lang="scss" scoped>
  .edit-method {
        padding: 10px 0;
        &__label {
            width: 30%;
        }
        &__input {
            margin: 0;
        }
        &__check {
            align-self: center;
            margin: auto;
        }
    }
</style>
